package com.tongran.rocketmq.controller;

import com.tongran.common.core.utils.poi.ExcelUtil;
import com.tongran.common.core.web.controller.BaseController;
import com.tongran.common.core.web.domain.AjaxResult;
import com.tongran.common.core.web.page.TableDataInfo;
import com.tongran.common.log.annotation.Log;
import com.tongran.common.log.enums.BusinessType;
import com.tongran.common.security.annotation.RequiresPermissions;
import com.tongran.rocketmq.domain.RmTemplateLinux;
import com.tongran.rocketmq.service.IRmTemplateLinuxService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * Linux系统监控项Controller
 * 
 * @author tongran
 * @date 2025-09-09
 */
@RestController
@RequestMapping("/linux")
@RequiresPermissions("rocketmq:linux")
public class RmTemplateLinuxController extends BaseController
{
    @Autowired
    private IRmTemplateLinuxService rmTemplateLinuxService;

    /**
     * 查询Linux系统监控项列表
     */
    @GetMapping("/list")
    public TableDataInfo list(RmTemplateLinux rmTemplateLinux)
    {
        startPage();
        List<RmTemplateLinux> list = rmTemplateLinuxService.selectRmTemplateLinuxList(rmTemplateLinux);
        return getDataTable(list);
    }

    /**
     * 导出Linux系统监控项列表
     */
    @Log(title = "Linux系统监控项", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, RmTemplateLinux rmTemplateLinux)
    {
        List<RmTemplateLinux> list = rmTemplateLinuxService.selectRmTemplateLinuxList(rmTemplateLinux);
        ExcelUtil<RmTemplateLinux> util = new ExcelUtil<RmTemplateLinux>(RmTemplateLinux.class);
        util.exportExcel(response, list, "Linux系统监控项数据");
    }

    /**
     * 获取Linux系统监控项详细信息
     */
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id)
    {
        return success(rmTemplateLinuxService.selectRmTemplateLinuxById(id));
    }

    /**
     * 新增Linux系统监控项
     */
    @Log(title = "Linux系统监控项", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody RmTemplateLinux rmTemplateLinux)
    {
        return toAjax(rmTemplateLinuxService.insertRmTemplateLinux(rmTemplateLinux));
    }

    /**
     * 修改Linux系统监控项
     */
    @Log(title = "Linux系统监控项", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody RmTemplateLinux rmTemplateLinux)
    {
        return toAjax(rmTemplateLinuxService.updateRmTemplateLinux(rmTemplateLinux));
    }

    /**
     * 删除Linux系统监控项
     */
    @Log(title = "Linux系统监控项", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids)
    {
        return toAjax(rmTemplateLinuxService.deleteRmTemplateLinuxByIds(ids));
    }
}
